
import RTIcap.*;
import java.util.*;

public class ObjectClassNaming
{

   Hashtable idToName = new Hashtable();
   Hashtable nameToId = new Hashtable();
   Hashtable idToObjRecord = new Hashtable();

   public 
   ObjectClassNaming() {}

   /**
   * returns the Object Id of the particular Object Name
   */
   public
   short getObjectClassHandle(String theName)
         throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
   {
       Short ret=(Short) nameToId.get(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return ret.shortValue();
    }

   /**
   */
   public
   String getObjectClassName(short theHandle)
           throws RTIcap.ObjectClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
   {
       String ret = (String) idToName.get(new Short(theHandle));

       if(ret==null) throw new RTIcap.ObjectClassNotDefined();

       return ret;
   } 

   /**
   */
   public
   short getAttributeHandle(String theName, short whichClass)
          throws RTIcap.ObjectClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
   {
       ObjectRecord ret = (ObjectRecord) idToObjRecord.get(new Short(whichClass));

       if(ret==null) throw new RTIcap.ObjectClassNotDefined();

       return ret.getAttributeHandle(theName);

   }// end of getAttributeHandle()

   /**
   */
   public
   String getAttributeName(short theHandle, short whichClass)
           throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
   {
       ObjectRecord ret = (ObjectRecord) idToObjRecord.get(new Short(whichClass));

       if(ret==null) throw new RTIcap.ObjectClassNotDefined();

       return ret.getAttributeName(theHandle);

   }// end of getAttributeName()

   /**
   */
   public
   ObjectRecord getObjectRecord(short whichClass)
           throws RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
   {
       return (ObjectRecord) idToObjRecord.get(new Short(whichClass));

   }// end of getObjectRecord()

   /**
   */
   public void 
   addObjectRecord(ObjectRecord rec)
   {

      idToName.put(new Short(rec.getId()),rec.getName());
      nameToId.put(rec.getName(),new Short(rec.getId()));
      idToObjRecord.put(new Short(rec.getId()),rec);
       
   }// end of addObjectRecord()

}// end of class
